/* sqExternalBitmap.h -- access to the C heap.  Author: Ian.Piumarta@inria.fr
 *
 * Last edited: Wed Oct 22 17:37:00 1997 by piumarta (Ian Piumarta) on olrik
 */

#include "sqUserPrims.h"

#define MAXARRAYS 64

oop externalBitmap_initialize		(oop extBitmap, oop byteSizeObj);
oop externalBitmap_byteAt		(oop extBitmap, oop indexObj);
oop externalBitmap_byteAtPut		(oop extBitmap, oop indexObj, oop valueObj);
oop externalBitmap_wordAt		(oop extBitmap, oop indexObj);
oop externalBitmap_wordAtPut		(oop extBitmap, oop indexObj, oop valueObj);
oop externalBitmap_basicSize		(oop extBitmap);
oop externalBitmap_class_decareLive	(oop rcvrClass, oop handleArray);
oop externalBitmap_copyToBitmap		(oop rcvrClass, oop bitmap);
oop externalBitmap_copyFromBitmap	(oop rcvrClass, oop bitmap);
oop externalBitmap_bitInvert		(oop extBitmap);
