/* sqUserPrims.c modified for ExternalBitmap primitives.
 *
 * Author: Ian.Piumarta@inria.fr
 *
 * Last edited: Wed Oct 22 17:36:30 1997 by piumarta (Ian Piumarta) on olrik
 */

#include "sqExternalBitmap.h"

char *up_version= "ExternalBitmap primitives installed";

void sqInitializeUserPrimitives(void)
{
  declarePrimitiveIndexFunctionArgs(1030, externalBitmap_initialize,	  1);
  declarePrimitiveIndexFunctionArgs(1031, externalBitmap_byteAt,		  1);
  declarePrimitiveIndexFunctionArgs(1032, externalBitmap_byteAtPut,	  2);
  declarePrimitiveIndexFunctionArgs(1033, externalBitmap_wordAt,		  1);
  declarePrimitiveIndexFunctionArgs(1034, externalBitmap_wordAtPut,	  2);
  declarePrimitiveIndexFunctionArgs(1035, externalBitmap_basicSize,	  0);  
  declarePrimitiveIndexFunctionArgs(1036, externalBitmap_class_decareLive, 1);
  declarePrimitiveIndexFunctionArgs(1037, externalBitmap_copyToBitmap,	  1);
  declarePrimitiveIndexFunctionArgs(1038, externalBitmap_copyFromBitmap,	  1);
  declarePrimitiveIndexFunctionArgs(1039, externalBitmap_bitInvert,	  0);
}
